/// <reference types="node" />
import * as http from "http";
import { JsonBody } from "./body/json";
import { TextBody } from "./body/text";
import { ErrorWithStatusCode } from "./error";
import { useExpress } from "./express";
import { ErrorHandler, Methods, Router } from "./router";
export { Router, ErrorWithStatusCode, useExpress, JsonBody, TextBody, Methods };
export interface IListenOptions {
    hostname?: string;
}
export declare class Routex extends Router {
    errorHandler: ErrorHandler;
    handler: (req: http.IncomingMessage, res: http.ServerResponse) => Promise<void>;
    listen(port?: number | string, { hostname }?: IListenOptions): Promise<{
        close: () => Promise<{}>;
        port: number;
        server: http.Server;
    }>;
}
